'**********************************************************
'Compiler            : BasCom
'Hardware            : Ansteuerung von Funksteckdosen
'Chip type           : ATTiny2313 (und 74HCT4066)
'Clock frequency     : 1,000000 MHz (intern)
'
'RoBue, 19.01.2009
'gendert H.S. 03.03.2009
'**********************************************************

$regfile = "attiny2313.dat"
$crystal = 1000000

' Es werden 4 Leitungen abgefragt (PORTD0-4),
' ob ein Pegelwechsel stattgefunden hat.
' Wenn Ja, wird dieser als kurzer Impuls (500ms)
' an einen Pin von PORTB ausgegeben.
' Damit werden 74HCT4066-Bausteine angesteuert,
' die einen Tastendruck des Handsenders simulieren.
' -> http://forum.mikrokopter.de/topic-395.html


' Ex -> Eingang
E1 Alias Pind.0
E2 Alias Pind.1
E3 Alias Pind.2
E4 Alias Pind.3

' Axy -> Ausgang
' x: 1-4 -> Eingang 1-4 zugeordnet
' y: e -> Port zum Einschalten, a -> Port zum Ausschalten
' -> E1:
A1e Alias Portb.0
A1a Alias Portb.1
' -> E2:
A2e Alias Portb.2
A2a Alias Portb.3
' -> E3:
A3e Alias Portb.4
A3a Alias Portb.5
' -> E4:
A4e Alias Portb.6
A4a Alias Portb.7

' Port fuer Eingabe
Config E1 = Input
Config E2 = Input
Config E3 = Input
Config E4 = Input
' Pullup ein
'Portd.0 = 1
'Portd.1 = 1
'Portd.2 = 1
'Portd.3 = 1

' Port zur Ausgabe (Schaltimpuls)
Config Portb = Output

Dim Eingang(4) As Byte
Dim I As Byte
Dim Test As Byte

' PROGRAMM:
' --------

' Initialisierung
' ---------------

' Zuruecksetzen des Eingabebuffers -> alles low
For I = 1 To 4
Eingang(i) = 1
Next I

' Alles ausschalten
'A1e = 0
A1a = 1
Wait 2
A1a = 0

'A2e = 0
A2a = 1
Wait 2
A2a = 0

'A3e = 0
A3a = 1
Wait 2
A3a = 0

'A4e = 0
A4a = 1
Wait 2
A4a = 0


' Schleife
' --------

Do
Test = E1
If Test <> Eingang(1) Then
   If Test = 1 Then
      A1e = 1
      Wait 2
      A1e = 0
      Eingang(1) = 1
   Else
      A1a = 1
      Wait 2
      A1a = 0
      Eingang(1) = 0
   End If
End If

Test = E2
If Test <> Eingang(2) Then
   If Test = 1 Then
      A2e = 1
      Wait 2
      A2e = 0
      Eingang(2) = 1
   Else
      A2a = 1
      Wait 2
      A2a = 0
      Eingang(2) = 0
   End If
End If

Test = E3
If Test <> Eingang(3) Then
   If Test = 1 Then
      A3e = 1
      Wait 2
      A3e = 0
      Eingang(3) = 1
   Else
      A3a = 1
      Wait 2
      A3a = 0
      Eingang(3) = 0
   End If
End If

Test = E4
If Test <> Eingang(4) Then
   If Test = 1 Then
      A4e = 1
      Wait 2
      A4e = 0
      Eingang(4) = 1
   Else
      A4a = 1
      Wait 2
      A4a = 0
      Eingang(4) = 0
   End If
End If

Loop